--
-- silageAdditive-Script
-- 
-- Author: Dominik Raith (DR_Modding)
--
--	adds using of silageAdditive and more yield when using it
--	adds a warning and a beepSound if almost Empty silageAdditive or almost full foragewagon
--
--
------------------------------------------------------------------------------------------------------
-- add new Specialization: silageAdditives

silageAdditives = {};
silageAdditives.modDir = g_currentModDirectory;
silageAdditives.MOD_NAME = g_currentModName;




-- Checks if all prerequisite specializations are loaded
function silageAdditives.prerequisitesPresent(specializations)
    return SpecializationUtil.hasSpecialization(FillUnit, specializations) and SpecializationUtil.hasSpecialization(ForageWagon, specializations);
end;


-- Register new Vehicel Type
--function silageAdditives.registerFunctions(vehicleType)
    --SpecializationUtil.registerFunction(vehicleType, "loadsilageAdditives",          silageAdditives.onFillUnitFillLevelChanged);
--end;

-- Register functions
--function silageAdditives.registerEventListeners(vehicleType)
 --   SpecializationUtil.registerEventListener(vehicleType, "onLoad", silageAdditives);
--	SpecializationUtil.registerEventListener(vehicleType, "onFillUnitFillLevelChanged", silageAdditives);
--end;


function silageAdditives.registerFunctions(vehicleType)
    SpecializationUtil.registerFunction(vehicleType, "loadSilageAdditivesXML", silageAdditives.loadSilageAdditivesXML)
end

function silageAdditives.registerEventListeners(vehicleType)
    SpecializationUtil.registerEventListener(vehicleType, "onLoad", silageAdditives)
    --SpecializationUtil.registerEventListener(vehicleType, "onPostLoad", silageAdditives)
    --SpecializationUtil.registerEventListener(vehicleType, "onReadStream", silageAdditives)
    SpecializationUtil.registerEventListener(vehicleType, "onUpdate", silageAdditives)
    SpecializationUtil.registerEventListener(vehicleType, "onUpdateTick", silageAdditives)
    --SpecializationUtil.registerEventListener(vehicleType, "onFillUnitFillLevelChanged", silageAdditives)
	SpecializationUtil.registerEventListener(vehicleType, "onEndWorkAreaProcessing", silageAdditives)
end


-- on load: seams to be a standard procedure
function silageAdditives:onLoad(savegame)
    self.spec_silageAdditives = self[string.format("spec_%s.silageAdditives", silageAdditives.MOD_NAME)]
    local spec = self.spec_silageAdditives
	
	spec.silageAdditives = {};
    local i = 0;
    while true do
        local key = string.format("vehicle.silageAdditives.silageAdditive(%d)", i);
        if not hasXMLProperty(self.xmlFile, key) then
            break;
        end;
        local silageAdditive = {}
        if self:loadSilageAdditivesXML(self.xmlFile, key, silageAdditive) then
            table.insert(spec.silageAdditives, silageAdditive);
        end;
        i = i + 1;
    end;
	
	spec.isFilling = false

	local spec = self.spec_forageWagon
	spec.fillTimer2 = 0

	--[[
	
    --XMLUtil.checkDeprecatedXMLElements(self.xmlFile, self.configFileName, "vehicle.sprayParticles.emitterShape", "vehicle.sprayer.effects.effectNode#effectClass='ParticleEffect'") --FS17 to FS19

    if self.isClient then
        spec.effects = g_effectManager:loadEffect(self.xmlFile, "vehicle.silageAdditives.effects", self.components, self, self.i3dMappings)
        --specSprayer.animationName = Utils.getNoNil(getXMLString(self.xmlFile, "vehicle.sprayer.animation#name"), "")
        --specSprayer.samples = {}
        --specSprayer.samples.work = g_soundManager:loadSampleFromXML(self.xmlFile, "vehicle.sprayer.sounds", "work", self.baseDirectory, self.components, 0, AudioGroup.VEHICLE, self.i3dMappings, self)
        --specSprayer.sampleFillEnabled = false
        --specSprayer.sampleFillStopTime = -1
       -- specSprayer.lastFillLevel = -1
        --specSprayer.animationNodes = g_animationManager:loadAnimations(self.xmlFile, "vehicle.sprayer.animationNodes", self.components, self, self.i3dMappings)
    end
	]]
	
end;


---Loads the values from the XML.
function silageAdditives:loadSilageAdditivesXML(xmlFile, key, silageAdditive)

    silageAdditive.usagePerLiter = Utils.getNoNil(getXMLFloat(xmlFile, key .. "#usagePerLiter"), 0.0003)
	silageAdditive.IncreaseFactor = Utils.getNoNil(getXMLFloat(xmlFile, key .. "#IncreaseFactor"), 0.1)
	silageAdditives.FillUnitIndex = Utils.getNoNil(getXMLInt(xmlFile, key.. "#fillUnitIndex"), 2)
	silageAdditives.volume = Utils.getNoNil(getXMLFloat(xmlFile, key.. "#volume"), 1)
	silageAdditives.fillLevelWarningsTextXML = Utils.getNoNil(getXMLBool(self.xmlFile, key .. "#fillLevelWarningsText"), true)
	silageAdditives.fillLevelWarningsSoundXML = Utils.getNoNil(getXMLBool(self.xmlFile, key .. "#fillLevelWarningsSound"), true)
	self.showSilageAdditiveWarning = true
	self.playSilageAdditiveWarningSound = true
    self.fillLevelChanged = false

	
	--silageAdditive.effects = g_effectManager:loadEffect(xmlFile, key.. ".effects", self.components, self, self.i3dMappings)
	
	
    return true
end


function silageAdditives:onEndWorkAreaProcessing(dt, hasProcessed, silageAdditive)
    local spec_forageWagon = self.spec_forageWagon
	local spec = self.spec_silageAdditives;	
    if self.isServer then
		for _, silageAdditive in pairs(spec.silageAdditives) do
			if self:getFillUnitExists(silageAdditives.FillUnitIndex) == true then
				if self:getFillUnitFillLevel(silageAdditives.FillUnitIndex) > 0 then
					if spec_forageWagon.workAreaParameters.lastPickupLiters > 0 then
						local loadInfo = self:getFillVolumeLoadInfo(spec_forageWagon.loadInfoIndex)
						local filledLiters = self:addFillUnitFillLevel(self:getOwnerFarmId(), spec_forageWagon.fillUnitIndex, spec_forageWagon.workAreaParameters.lastPickupLiters * silageAdditive.IncreaseFactor, spec_forageWagon.workAreaParameters.forcedFillType, ToolType.UNDEFINED, loadInfo)
						local usedSilageAdditiveLiter = self:addFillUnitFillLevel(self:getOwnerFarmId(), silageAdditives.FillUnitIndex, -spec_forageWagon.workAreaParameters.lastPickupLiters * silageAdditive.usagePerLiter, self:getFillUnitFillType(silageAdditives.FillUnitIndex), ToolType.UNDEFINED, nil)
						spec_forageWagon.fillTimer2 = 500
					end
				end
			end
		end
    end
end

--[[
-- onFillUnitFillLevelChanged: usage of fillUnits
function silageAdditives:onFillUnitFillLevelChanged(fillUnitIndex, fillLevelDelta, fillTypeIndex, toolType, fillPositionData, appliedDelta)
    local spec = self.spec_silageAdditives;	
	
	local fillUnitIndex1 = 1;
	local fillUnitIndex2 = 2;
    
	if self:getFillUnitExists(fillUnitIndex2) == true then
		for _, silageAdditive in pairs(spec.silageAdditives) do
			
			if fillUnitIndex == fillUnitIndex1 then
			
				local fillLevel2 = self:getFillUnitFillLevel(fillUnitIndex2);
				
				--if fillLevel2 <= 0 then
					--local fillType = self:getFillUnitFirstSupportedFillType(fillUnitIndex2)
				--	return g_i18n:getText("warning_refillSilageAdditive"):format(g_fillTypeManager:getFillTypeByIndex(fillType).title)
				--end;

				if silageAdditives.delayTime <= 0 then
					if fillLevel2 > 0 and fillLevelDelta > 0 then			
							
							self:addFillUnitFillLevel(self:getOwnerFarmId(), fillUnitIndex2, -fillLevelDelta * silageAdditive.usagePerLiter * 6.1, self:getFillUnitFillType(fillUnitIndex2), ToolType.UNDEFINED, nil) -- use silageAdditive 
							self:addFillUnitFillLevel(self:getOwnerFarmId(), fillUnitIndex1, fillLevelDelta * silageAdditive.IncreaseFactor * 6.1, self:getFillUnitFillType(fillUnitIndex1), ToolType.UNDEFINED, fillPositionData) -- 0.1 --> 10% more yield
							--fillLevelDelta*0,5 --> Einfassmenge wird verdoppelt !
							--fillLevelDelta*0,25 -> *0,33333
							--fillLevelDelta*0,25 -> *0,11111 i.O!       111 L Siliermittel verbraucht 10000*0.01 --> hätten 100 L Verbrauch sein sollen :/   
							self.fillLevelChanged = true
							
							-- ohne 7500 L 		mit*2: 7607 -> 1,4%		mit*3: 7749 -> 3,3%		mit*4: 7837 -> 4,5%		
							-- mit*6: 8155 -> 8,7%	 	mit*6,15: 8345 -> 11,2%		mit*6,5: 8566 -> 14,2%		mit*7: 8981 -> 19,7%
							
					end;
				end;
			end;

		end;
	end
    	
end;
]]

-- set a timer because the addFillUnitFillLevel function causes performance issues!
--silageAdditives.delayTime = 30;
--silageAdditives.delayTime2 = 100000;

function silageAdditives:onUpdateTick(dt)
--[[
    if silageAdditives.delayTime < 0 then
        --Run addFillUnitFillLevel
		silageAdditives.delayTime = 30;
    else
        silageAdditives.delayTime = silageAdditives.delayTime - 1;
    end;
	]]
	
	local spec = self.spec_forageWagon
    if self.isServer then
        local isFilling = false
        if spec.fillTimer2 > 0 then
            spec.fillTimer2 = spec.fillTimer2 - dt
            isFilling = true
        end
		local spec = self.spec_silageAdditives;	
		spec.isFilling = isFilling
    end
end;


-- load BeepSound
BeepSound = createSample("BeepSound")
local file = g_currentModDirectory.."sound/beepSound.mp3"
loadSample(BeepSound, file, false)


---Returns almost empty warning text and a warning sound 
function silageAdditives:onUpdate(dt)
    local spec = self.spec_silageAdditives

	local fillUnitIndex = silageAdditives.FillUnitIndex;
	local volume = silageAdditives.volume
	
	--local spec_fillUnit = self.spec_fillUnit
    --local isFilling = spec_fillUnit.fillTrigger.isFilling 
	if self:getFillUnitExists(fillUnitIndex) == true then
		if self.isClient then
			if spec.isActive then
				local fillLevel2 = self:getFillUnitFillLevel(fillUnitIndex);
				if fillLevel2 ~= nil then
					if fillLevel2 > 0 and fillLevel2 <= 3 then
						if spec.isFilling == true then
							if silageAdditives.fillLevelWarningsTextXML == true then
								if self.showSilageAdditiveWarning == true then 
									g_currentMission:showBlinkingWarning(g_i18n:getText("warning_silageAdditiveAlmostEmpty"), 5000)
									self.showSilageAdditiveWarning = false
								end
							end
							if silageAdditives.fillLevelWarningsSoundXML == true then
								if self.playSilageAdditiveWarningSound == true then 
									playSample(BeepSound ,1 ,volume,1 ,0 ,0)	-- (sampleName, howOftenPlay, Volume, ?, ?)
									self.playSilageAdditiveWarningSound = false
								end
							end
						end
					else
					self.playSilageAdditiveWarningSound = true
					self.showSilageAdditiveWarning = true
					end
				end
			end
		end
	end
		
end















--[[
function Sprayer:onLoad(savegame)
    local spec = self.spec_sprayer
    XMLUtil.checkDeprecatedXMLElements(self.xmlFile, self.configFileName, "vehicle.sprayParticles.emitterShape", "vehicle.sprayer.effects.effectNode#effectClass='ParticleEffect'") --FS17 to FS19

    if self.isClient then
        spec.effects = g_effectManager:loadEffect(self.xmlFile, "vehicle.sprayer.effects", self.components, self, self.i3dMappings)
        spec.animationName = Utils.getNoNil(getXMLString(self.xmlFile, "vehicle.sprayer.animation#name"), "")
        spec.samples = {}
        spec.samples.work = g_soundManager:loadSampleFromXML(self.xmlFile, "vehicle.sprayer.sounds", "work", self.baseDirectory, self.components, 0, AudioGroup.VEHICLE, self.i3dMappings, self)
        spec.sampleFillEnabled = false
        spec.sampleFillStopTime = -1
        spec.lastFillLevel = -1
        spec.animationNodes = g_animationManager:loadAnimations(self.xmlFile, "vehicle.sprayer.animationNodes", self.components, self, self.i3dMappings)
    end
end
]]
--[[
function silageAdditives:onDelete()
    if self.isClient then
        local spec = self.spec_silageAdditives
        g_effectManager:deleteEffects(spec.effects)
        --g_animationManager:deleteAnimations(spec.animationNodes)
        for _, silageAdditive in ipairs(spec.silageAdditives) do
            g_effectManager:deleteEffects(silageAdditive.effects)
            --g_soundManager:deleteSamples(sprayType.samples)
            --g_animationManager:deleteAnimations(sprayType.animationNodes)
        end
    end
end



function silageAdditives:onTurnedOn()
    local spec = self.spec_silageAdditives
    if self.isClient then
		g_effectManager:startEffects(spec.effects)
		g_effectManager:startEffects(silageAdditive.effects)
    end
end



function silageAdditives:onTurnedOff()
    local spec = self.spec_silageAdditives
    if self.isClient then
        g_effectManager:stopEffects(spec.effects)
        -- deactivate effects on all spray types (the spray type has may changed during activation)
        for _, silageAdditive in ipairs(spec.silageAdditives) do
            g_effectManager:stopEffects(silageAdditive.effects)
        end
    end
end

]]
--[[
function Sprayer:loadSprayTypeFromXML(xmlFile, key, sprayType)
    sprayType.fillUnitIndex = Utils.getNoNil(getXMLInt(xmlFile, key.. "#fillUnitIndex"), 1)
    sprayType.unloadInfoIndex = Utils.getNoNil(getXMLInt(xmlFile, key.. "#unloadInfoIndex"), 1)
    sprayType.fillVolumeIndex = getXMLInt(xmlFile, key.. "#fillVolumeIndex")
    sprayType.samples = {}
    sprayType.samples.work = g_soundManager:loadSampleFromXML(xmlFile, key.. ".sounds", "work", self.baseDirectory, self.components, 0, AudioGroup.VEHICLE, self.i3dMappings, self)
    sprayType.effects = g_effectManager:loadEffect(xmlFile, key.. ".effects", self.components, self, self.i3dMappings)
    sprayType.animationNodes = g_animationManager:loadAnimations(xmlFile, key.. ".animationNodes", self.components, self, self.i3dMappings)
    sprayType.turnedAnimation = getXMLString(self.xmlFile, key .. ".turnedAnimation#name") or ""
    sprayType.ai = {}
    sprayType.ai.leftMarker = I3DUtil.indexToObject(self.components, getXMLString(self.xmlFile, key .. ".ai.areaMarkers#leftNode"), self.i3dMappings)
    sprayType.ai.rightMarker = I3DUtil.indexToObject(self.components, getXMLString(self.xmlFile, key .. ".ai.areaMarkers#rightNode"), self.i3dMappings)
    sprayType.ai.backMarker = I3DUtil.indexToObject(self.components, getXMLString(self.xmlFile, key .. ".ai.areaMarkers#backNode"), self.i3dMappings)
    sprayType.ai.sizeLeftMarker = I3DUtil.indexToObject(self.components, getXMLString(self.xmlFile, key .. ".ai.sizeMarkers#leftNode"), self.i3dMappings)
    sprayType.ai.sizeRightMarker = I3DUtil.indexToObject(self.components, getXMLString(self.xmlFile, key .. ".ai.sizeMarkers#rightNode"), self.i3dMappings)
    sprayType.ai.sizeBackMarker = I3DUtil.indexToObject(self.components, getXMLString(self.xmlFile, key .. ".ai.sizeMarkers#backNode"), self.i3dMappings)
    sprayType.ai.collisionTrigger = I3DUtil.indexToObject(self.components, getXMLString(self.xmlFile, key .. ".ai.collisionTrigger#node"), self.i3dMappings)
    if sprayType.ai.collisionTrigger ~= nil then
        local rigidBodyType = getRigidBodyType(sprayType.ai.collisionTrigger)
        if rigidBodyType ~= "Kinematic" then
            g_logManager:xmlWarning(self.configFileName, "'aiCollisionTrigger' is not a kinematic body type")
        end
    end
    local fillTypesStr = getXMLString(xmlFile, key.. "#fillTypes")
    if fillTypesStr ~= nil then
        sprayType.fillTypes = StringUtil.splitString(" ", fillTypesStr)
    end
    sprayType.objectChanges = {}
    ObjectChangeUtil.loadObjectChangeFromXML(self.xmlFile, key, sprayType.objectChanges, self.components, self)
    ObjectChangeUtil.setObjectChanges(sprayType.objectChanges, false)
    sprayType.usageScale = {}
    sprayType.usageScale.workingWidth = Utils.getNoNil(getXMLFloat(self.xmlFile, key..".usageScales#workingWidth"), 12)
    return true
end
]]

